//+------------------------------------------------------------------+
//|                                                 euroform-exp.mq4 |
//|                Copyright  2006, Nick Bilak, beluck[AT]gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Nick Bilak"
#property link      "http://www.mql4.info/"
#include <stdlib.mqh>

#define MODE_DEMA    4
#define MODE_TEMA    5
#define MODE_T3MA    6
#define MODE_JMA     7
#define MODE_HMA     8
#define MODE_DECEMA  9
#define MODE_SATL    10
#define MODE_TMA     11
#define MODE_FATL    12
#define MODE_RSTL    13
#define MODE_SDL     14
#define MODE_Kaufman2 15
#define MODE_NonLagMA 16

extern int  MagicNumber=197893;
extern string EAName="euroform";

extern double ProfitExit = 5; //% profit exit per position

extern double EquityGainPercent = 3; //Global percentage of equity exit

extern int TakeProfit1=50; // 1st pip Exit

extern int _3bartrailpips=2; //3bar trailing stop
extern int BreakEven=6; // Breakeven
extern int StopLoss=20;  // Initial Stop

extern string _Parameters_Trailing = "-----  ";
extern bool UseTrailing  = false;   // 
extern int  LevelProfit1 = 50;     // First profit level
extern int  LevelMoving1 = 25;      // First level of moving
extern int  LevelProfit2 = 100;     // Second profit level
extern int  LevelMoving2 = 50;     // Second level of moving
extern int  LevelProfit3 = 150;     // Third profit level
extern int  LevelMoving3 = 75;     // Third level of moving
extern int  TrailingStop = 10;     // Trailing Stop
extern int  TrailingStep = 5;      // Step
extern int  clModifyBuy = Aqua;
extern int  clModifySell = Tomato;
extern bool UseSound = False;
extern string NameFileSound = "expert.wav";


extern int  OrderPipsDiff=5;
extern int ATRStopPeriod = 25;
extern double ATRStopRatio = 2.2;
extern double ATRBreakevenStopRatio = 2.2;
extern int ATREnrtyPeriod = 25;
extern double ATREntryRatio = 2;

extern double First_Target = 20;
extern double Target_Increment = 5;
extern double Close_Lots = 0.1;
extern bool Move_Stops = false;
extern double First_Stop_Target = 5;
extern double First_Stop = 20;
extern double Second_Stop_Target = 5;
extern double Second_Stop = 20;
//extern bool Use_Max_Loss = false;
//extern double Max_Loss = 25;

extern string i0="_indicators params_";
extern string i1="__volatility__";
extern int rtP=7;
extern int Voltrp=9;
extern int Voltype=1;
extern double  VolatilityHL=10;

extern string i2="__rsi2ma__";
extern int MA1pr=6;
extern int MA1type=14;
/*
MODE_SMA       0     Simple moving average, 
MODE_EMA       1     Exponential moving average, 
MODE_SMMA      2     Smoothed moving average, 
MODE_LWMA      3     Linear weighted moving average.
MODE_DEMA      4     Double Exponential Moving Average. 
MODE_TEMA      5     Triple Exponential Moving Average.
MODE_T3MA      6     T3 Moving Average. 
MODE_JMA       7     Jurik Moving Average. 
MODE_HMA       8     Hull Moving Average. 
MODE_DECEMA    9     DECEMA Moving Average. 
MODE_SALT      10    Slow Adaptive Trend Line
MODE_TMA       11    Triangular moving average
MODE_FATL      12    Fast Adaptive Trend Line. 
MODE_RSTL      13    Referance Slow Trend Line 
MODE_SDL       14    Slope Directional Line
MODE_Kaufman2  15    Kama / Kaufman2 Indicator
MODE_NonLagMA  16    NonLagMA 
*/
extern int MA2pr=8;
extern int MA2type=1;
extern int RSItpr=3;
extern double  MAofRSIUpHL=75;
extern double  MAofRSIDwnHL=25;

extern int MOMPeriod = 10;

extern double TM_Period = 7;
extern double TM_Shift = 2;

extern int       barsToCount = 2000;
extern double        UpperTarget = 3.0;
extern double        LowerTarget = -3.0;

extern string i3="__deltastop__";
extern int     Mode=0; //0 - auto, 1 - manual
extern double  DeltaPrice=0.001;
extern int     ATRperiod=3;
extern double  ATRratio=2.522;

extern int    ConsecutiveTrades=3;
extern int CancelOrderBars=4;

extern double Lots = 0.01;  
extern double MaximumRisk = 2;
extern int    LotDigits = 1;  
extern bool   FixedLot = false;

extern int    slippage=2;   	//slippage for market order processing
extern int    shift=1;			//shift to current bar for entry 
extern int    OrderTriesNumber=10;

bool buysig,sellsig,closebuy,closesell,cancel,addbuy,addsell,exit,remorder; 
int ord,tries,last,buys,sells,SL, BreakEvenStop,co,mkt,lastsig,Long,Long2,Long3,Long4,Short,Short2,Short3,Short4;
double atrstop,atrentry,_1stentry,entryprice,_1stlots,avgpositionprofit,hbuy,lsell,curprof,tickvalue;
double nextTP;
bool sl;
int range = 5;
int multiplier;


int init()
{
   sl=false;
   nextTP = First_Target;
   //getMaxLoss();
   //----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
	//----------------------- SOURCE : PENGIE
   MagicNumber    = subGenerateMagicNumber(MagicNumber, Symbol(), Period());
   tickvalue = MarketInfo(Symbol(),MODE_TICKVALUE);
   
	//----
   return(0);
}


//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()  {
	
   //---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
	
   co=CalculateCurrentOrders(Symbol());
	
   CheckForSignals();
   if (co>0) CheckForClose();
   CheckForOpen();
   
   co=CalculateCurrentOrders(Symbol());
	
   if (mkt>0) {
      BreakEvenStop(BreakEven,0);
      Trail3Bar();
      TrailingPositions();
      getOpenOrders();
      
		{
			double pcnt =( (AccountEquity()-AccountBalance()) / AccountBalance())*100;
			Print("Account equity = ",AccountEquity());
			Print("Account balance = ",AccountBalance());
			
			if(pcnt>EquityGainPercent)
			{ 
				int total = OrdersTotal();
				for(int i=total-1;i>=0;i--)
				{
					OrderSelect(i, SELECT_BY_POS);
					int type   = OrderType();
					
					bool result = false;
					
					switch(type)
					{
						//Close opened long positions
					case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
						break;
						
						//Close opened short positions
					case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
						break;
						
						//Close pending orders
					case OP_BUYLIMIT  :
					case OP_BUYSTOP   :
					case OP_SELLLIMIT :
					case OP_SELLSTOP  : result = OrderDelete( OrderTicket() );
					}
					
					if(result == false)
					{
						Alert("Order " , OrderTicket() , " failed to close. Error:" , GetLastError() );
						Sleep(3000);
					}  
				}
				
				
				Print("ALL ORDERS CLOSE-->Locked in on Profits");
			}
			return(0);
			
		}
		//+------------------------------------------------------------------+
   }
	
}

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
{
   int ord; mkt=0;
	//----
   for(int i=0;i<OrdersTotal();i++)  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;
      if(OrderSymbol()==symbol && OrderMagicNumber()== MagicNumber) {
         ord++;
         if (OrderType()==OP_BUY || OrderType()==OP_SELL) mkt++;
      }
   }
	//---- return orders volume
   return(ord);
}

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals() {
	
	addsell=false;
	addbuy=false;
	buysig=false;
	sellsig=false;
	closebuy=false;
	closesell=false;
	exit=false;
	remorder=false;
	
	
	
	
	double VolCH=iCustom(NULL,0,"volatility",rtP,Voltrp,Voltype,0,shift);
	double RSIndex1=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,0,shift);
	double MAofRSI11=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,1,shift);
	double MAofRSI21=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,2,shift);
	double RSIndex2=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,0,shift+1);
	double MAofRSI12=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,1,shift+1);
	double MAofRSI22=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,2,shift+1);
	double TrStop=iCustom(NULL,0,"delta-stop",Mode,DeltaPrice,ATRperiod,ATRratio,0,shift);
	double zscore=iCustom(NULL,0,"zscore1_timeframe",barsToCount,0,shift);
	double TML=iCustom(NULL,0,"TrendManager",TM_Period,TM_Shift,1,shift);
	double TMS=iCustom(NULL,0,"TrendManager",TM_Period,TM_Shift,0,shift);
	double MOM = iCustom (NULL,0,"Momentum-ZL",MOMPeriod,0,shift);
	atrstop=iATR(NULL,0,ATRStopPeriod,shift);
	atrentry=iATR(NULL,0,ATREnrtyPeriod,shift);
	
	if (ord==0) { _1stentry=-1; _1stlots=0; }
	int numentries;
	if (ord>0) {
		if (atrentry*ATREntryRatio!=0.0) numentries = MathFloor((Ask-_1stentry)/(atrentry*ATREntryRatio));
		if (numentries>ord) addbuy=true;
	}
	if (ord<0) {
		if (atrentry*ATREntryRatio!=0.0) numentries = MathFloor((_1stentry-Bid)/(atrentry*ATREntryRatio));
		if (numentries>(-ord)) addsell=true;
	}
	SL=atrstop*ATRStopRatio/Point;
	
	double VolHL=VolatilityHL;
	double HL3=UpperTarget;
	double HL4=LowerTarget;
	double HL1=MAofRSIUpHL;
	double HL2=MAofRSIDwnHL;
	double HLM=50;
	
	
	//bool Long = cross(MAofRSI,MAofRSI2) and VolCH>VolHL and RSIndex<HLM and RSIndex>HL2 and TrStop<C;
	bool Long = MAofRSI11>MAofRSI21 && MAofRSI12<=MAofRSI22 && VolCH>VolHL && RSIndex1<HLM && RSIndex1>HL2 && TrStop<Close[shift] && TML && MOM>0.0;
	//bool Short = cross(MAofRSI2,MAofRSI) and VolCH>VolHL and RSIndex<HL1 and RSIndex>HLM and TrStop>C;
	bool Short = MAofRSI11<MAofRSI21 && MAofRSI12>=MAofRSI22 && VolCH>VolHL && RSIndex1<HL1 && RSIndex1>HLM && TrStop>Close[shift] && TMS && MOM<0.0;
	//bool Long2 = cross(MAofRSI,HLM) and cross(MAofRSI2,HLM) and VolCH>VolHL;
	bool Long2 = MAofRSI11>HLM && MAofRSI12<HLM && MAofRSI21>HLM && MAofRSI22<HLM && VolCH>VolHL && TrStop<Close[shift] && TML && MOM>0.0;
	//bool Short2 = cross(HLM,MAofRSI) and cross(HLM,MAofRSI2) and VolCH>VolHL;
	bool Short2 = MAofRSI11<HLM && MAofRSI12>HLM && MAofRSI21<HLM && MAofRSI22>HLM && VolCH>VolHL && TrStop>Close[shift] && TMS && MOM<0.0;
	//bool Long3 = RSIndex-ref(RSIndex,-1)>20;
	bool Long3 = RSIndex1-RSIndex2>60 && TrStop<Close[shift] && TML && MOM>0.0;
	//bool Short3 = ref(RSIndex,-1)-RSIndex>20;
	bool Short3 = RSIndex2-RSIndex1>60 && TrStop>Close[shift] && TMS && MOM<0.0;
	
	bool Long4 = zscore > HL4 && TML && MOM<0.0;
	
	bool Short4 = zscore < HL3 && TMS && MOM>0.0;
	
	buysig = Long || Long2 || Long3 || Long4;
	sellsig = Short || Short2 || Short3 || Short4;
	
	closebuy=sellsig;
	closesell=buysig;
	
	if (curprof>=AccountEquity()*ProfitExit/100.0) {
		exit=true;
	}
	if (last>0 && (Time[0]-last)/(Period()*60)>=CancelOrderBars) {
		remorder=true;
	}
}

void CheckForOpen() {
   int    res,tr;
	
	//---- sell conditions
   co=CalculateCurrentOrders(Symbol());
   if(sellsig && lastsig!=-1)  {
      co=CalculateCurrentOrders(Symbol());
	   if (co==0) {
			if ( Short == true)Print(" Short signal taken ");
			if ( Short2 == true)Print(" Short2 signal taken ");
			if ( Short3 == true)Print(" Short3 signal taken ");
			if ( Short4 == true)Print(" Short4 signal taken ");
			res = OpenStop(OP_SELLSTOP,LotsRisk(StopLoss), Low[shift]-OrderPipsDiff*Point, StopLoss, TakeProfit1);
	   }
	   lastsig=-1;
	   last=Time[0];
      return;
   }
	//---- buy conditions
   co=CalculateCurrentOrders(Symbol());
   if(buysig && lastsig!=1)  {
      co=CalculateCurrentOrders(Symbol());
	   if (co==0) {
			if ( Long == true) Print(" Long signal taken ");
			if ( Long2 == true)Print(" Long2 signal taken ");
			if ( Long3 == true) Print(" Long3 signal taken ");
			if ( Long4 == true)Print(" Long4 signal taken ");
			res = OpenStop(OP_BUYSTOP,LotsRisk(StopLoss), High[shift]+OrderPipsDiff*Point, StopLoss, TakeProfit1);
	   }
	   last=Time[0];
	   lastsig=1;
      return;
   }
}
bool CloseAtMarket(int ticket,double lot) {
   //fault tolerant market order closing
   bool bres=false; int tr;
   tries=0;
   while (!bres && tries<OrderTriesNumber) {
      RefreshRates();
      bres=OrderClose(ticket,lot,OrderClosePrice(),slippage,White);
      tries++;
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
   }
   if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
}

int OpenStop(int mode,double lot, double prc, int SL, int TP) {
   int    res,tr,col;
   string mail;
   double openprice,sl,tp,stlev;
   tries=0;
   stlev=(1+MarketInfo(Symbol(),MODE_STOPLEVEL))*Point;
   while (res<=0 && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      if (mode==OP_SELLSTOP) {
         if (prc<=Bid-stlev) openprice=prc; 
         else openprice=Bid-stlev; 
         if (SL>0) sl=openprice+SL*Point;
         if (TP>0) tp=openprice-TP*Point;
			
         col=Red;
      } else
      if (mode==OP_BUYSTOP) {
         if (prc>=Ask+stlev) openprice=prc; 
         else openprice=Ask+stlev; 
         if (SL>0) sl=openprice-SL*Point;
         if (TP>0) tp=openprice+TP*Point;
			
         col=Blue;
      } else return;
      Print(Ask," ",Bid," ",Symbol(),"  ",mode,"  ",lot,"  ",openprice,"  ",sl,"  ",tp,"  ");
      res=OrderSend(Symbol(),mode,lot,openprice,slippage,sl,tp,EAName+"_"+ MagicNumber, MagicNumber,0,col);
      tries++;
   }
   if (res<=0) Print("Error opening pending order : ",ErrorDescription(GetLastError()));
   return(res);
} 
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()  {
   bool bres; int tr;
   for(int i=0;i<OrdersTotal();i++)  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)  continue;
      if(OrderMagicNumber()!= MagicNumber || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY && exit || closebuy) {
         bres=CloseAtMarket(OrderTicket(),OrderLots());
         continue;
      }
      if(OrderType()==OP_SELL && exit || closesell) {
         bres=CloseAtMarket(OrderTicket(),OrderLots());
         continue;
      }
      if(OrderType()==OP_BUYSTOP && (closebuy || remorder)) {
         bres=DeletePending(OrderTicket());
         continue;
      }
      if(OrderType()==OP_SELLSTOP && (closesell || remorder)) {
         bres=DeletePending(OrderTicket());
         continue;
      }
   }
}

bool DeletePending(int ticket) {
   bool bres=false; int tr;
   tries=0;
   while (!bres && tries<OrderTriesNumber) {
      bres=OrderDelete(ticket);
      tries++;
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
   }
   if (!bres) Print("Error deleting order : ",ErrorDescription(GetLastError()));
   return (bres);
}

double LotsRisk(int StopLoss)  { 
   double lot=Lots;
   int SL=StopLoss;
   if (SL==0) SL=100;
	//---- select lot size
   if (!FixedLot)
      lot=AccountFreeMargin()*MaximumRisk*0.001/SL;
   lot=NormalizeDouble(lot,LotDigits);
	//---- return lot size
   if(lot<MarketInfo(Symbol(),MODE_MINLOT)) lot=MarketInfo(Symbol(),MODE_MINLOT);
   return(lot);
}


double getPipValue(double ord,int dir)
{
   double val;
   RefreshRates();
   if(dir == 1) val=(NormalizeDouble(ord,Digits) - NormalizeDouble(Ask,Digits));
   else val=(NormalizeDouble(Bid,Digits) - NormalizeDouble(ord,Digits));
   val = val/Point;
   return(val);   
}


//double getMaxLoss()
//{
// double calcMaxLoss;
//  calcMaxLoss = Max_Loss;
//  return(calcMaxLoss);
//}


void getOpenOrders()
{
   int nsl, nsd;
   string mngMagic;
   int totalorders = OrdersTotal();
   for(int j=totalorders-1; j>=0; j--)
	{  
		if (!OrderSelect(j, SELECT_BY_POS, MODE_TRADES)) continue;
		if((OrderType() == OP_BUY || OrderType() == OP_SELL) && OrderSymbol() == Symbol()&&( MagicNumber==0 ||  MagicNumber == OrderMagicNumber()))
		{
			
			double val=getPipValue(OrderOpenPrice(),OrderType());
			//int val = OrderProfit()/(OrderLots()*10);
			//if(Use_Max_Loss && Max_Loss > 0) killTrade(val,OrderTicket());
			if(Move_Stops) checkStops(val,OrderTicket());
			takeProfit(val,OrderTicket());            
			
		}
		
		if( MagicNumber == 0)
         mngMagic = "All "+Symbol()+" trades.";
		else
         mngMagic = "Trades with magic number = "+ MagicNumber;
		
		
		if(sl==0)
		{
			nsl = First_Stop_Target;
			nsd = First_Stop;
		}
		else
		{
			nsl = Second_Stop_Target;
			nsd = Second_Stop;
		}
		//RefreshRates();
		Comment("Order Open: ",OrderOpenPrice(), 
         "\nPip Count: ", val,
         "\nNext Stop Target: ",nsl,
         "\nNext Stop Differential: ", nsd,
         "\nNext TP: ", nextTP,
         "\nSL: ",sl,
         //"\nMax Loss: ", getMaxLoss(),
         "\nManaging: ",mngMagic);
		
		
	}  
}

//========== FUNCTION takeProfit
void takeProfit(int pips, int ticket)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {
		
      if(pips >= nextTP && pips < (nextTP + Target_Increment))
      {
         if(OrderType()==1)
         {
            if(OrderClose(ticket, Close_Lots, Ask, 3, YellowGreen))
					nextTP+=Target_Increment;
            else
					Print("Error closing order : ",GetLastError()); 
         } 
         else
         {
            if(OrderClose(ticket, Close_Lots, Bid, 3, YellowGreen))
					nextTP+=Target_Increment;
            else
					Print("Error closing order : ",GetLastError()); 
         }
			
      }
		
   }
}

//== end function



//========== FUNCTION moveStops
void checkStops(int pips,int ticket)
{
   if(sl==0 && pips > Second_Stop_Target )
   {
      if(pips <= First_Stop_Target && pips < (Second_Stop_Target ))
      {
         moveStops(ticket, First_Stop );
      }
   }
   else if(sl==1 || pips >= Second_Stop_Target )
   {
      if(pips >= Second_Stop_Target )
      {
         moveStops(ticket,Second_Stop );
      }
   }
	
	
}

//== end function

//========== FUNCTION moveStops
void moveStops(int ticket,int stopDiff)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {
      Print("moveStops called ",ticket, " ",stopDiff);
      if(OrderType()==1) 
      {
			OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()-stopDiff , OrderTakeProfit(),0,Plum);
			sl=1;
      }
      else 
      {
			OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()+stopDiff , OrderTakeProfit(),0,Plum);
			sl=1;
      }
   }
   
	
   
}
void BreakEvenStop(int BES, int BELP) {
   //move stoploss to lock some profit
   bool bres;
   double StopLoss;
   if ( BES > 2 ) {
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != Symbol() || OrderMagicNumber() !=  MagicNumber )  continue;
         if ( OrderType() == OP_BUY ) {
            if ( Bid < OrderOpenPrice()+BES*Point )  continue;
            StopLoss = OrderOpenPrice()+BELP*Point;
            if ( StopLoss > OrderStopLoss() ) {
					bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
					if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
            }
         }
			
         if ( OrderType() == OP_SELL ) {
            if ( Ask > OrderOpenPrice()-BES*Point )  continue;
            StopLoss = OrderOpenPrice()-BELP*Point;
            if ( StopLoss < OrderStopLoss() ) {
					bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
					if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
            }
         }
      }
   }
   return;
}


void Trail3Bar() {
   //_3bartrailpips
   bool bres;
   double StopLoss,H3,L3=99999;
   int i=0,cnt=3;
   
   while (i<=cnt) {
      i++;
      if (i>Bars-1) break;
      if (High[i]<=High[i+1] && Low[i]>=Low[i+1]) { cnt++; continue; } //skip inside Bar
      H3=MathMax(H3,High[i]);
      L3=MathMin(L3,Low[i]);
   }
   L3=L3-_3bartrailpips*Point;
   H3=H3+_3bartrailpips*Point;
   double stlev=(1+MarketInfo(Symbol(),MODE_STOPLEVEL))*Point;
   if (L3>=Bid-stlev) L3=Bid-stlev; 
   if (H3<=Ask+stlev) H3=Ask+stlev; 
   for (i = 0; i < OrdersTotal(); i++) {
      if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
      if ( OrderSymbol() != Symbol() || OrderMagicNumber() !=  MagicNumber )  continue;
      if ( OrderType() == OP_BUY ) {
         StopLoss = L3;
         if ( StopLoss > OrderStopLoss() ) {
				bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
				if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
         }
      }
		
      if ( OrderType() == OP_SELL ) {
         StopLoss = H3;
         if ( StopLoss < OrderStopLoss() || OrderStopLoss()<Point ) {
				bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
				if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
         }
      }
   }
}
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void TrailingPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) {
				ThreeLevelSystemOfOutput();
			}
		}
	}
}

//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void ThreeLevelSystemOfOutput() {
	int pr=ProfitPosition(), sl=StopLossInPoint();
	int sp=MarketInfo(OrderSymbol(), MODE_SPREAD);
	
	if (pr>LevelProfit1 && pr<=LevelProfit2 && sl<LevelMoving1) ModifyStopLossInPoint(LevelMoving1);
	if (pr>LevelProfit2 && pr<=LevelProfit3 && sl<LevelMoving2) ModifyStopLossInPoint(LevelMoving2);
	if (pr>LevelProfit3 && sl<LevelMoving3) ModifyStopLossInPoint(LevelMoving3);
	if (pr>LevelMoving3+TrailingStop+TrailingStep) {
		SimpleTrailingPositions();
	}
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void SimpleTrailingPositions() {
	double pBid, pAsk, pp=MarketInfo(OrderSymbol(), MODE_POINT);
	
	if (OrderType()==OP_BUY) {
		pBid=MarketInfo(OrderSymbol(), MODE_BID);
		if (pBid-OrderOpenPrice()>TrailingStop*pp) {
			if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp) {
				ModifyStopLoss(pBid-TrailingStop*pp, clModifyBuy);
				return;
			}
		}
	}
	if (OrderType()==OP_SELL) {
		pAsk=MarketInfo(OrderSymbol(), MODE_ASK);
		if (OrderOpenPrice()-pAsk>TrailingStop*pp) {
			if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) {
				ModifyStopLoss(pAsk+TrailingStop*pp, clModifySell);
				return;
			}
		}
	}
}

//+------------------------------------------------------------------+
//|   StopLoss                                          |
//| :                                                       |
//|   ldStopLoss -  StopLoss                                  |
//+------------------------------------------------------------------+
void ModifyStopLoss(double ldStopLoss, color clModify) {
	bool fm;         //   
	int  err;
	
	if (IsTradeAllowed()) {
		fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,clModify);
		if (!fm) {
			err=GetLastError();
			Print("Error(",err,") modifying: ",ErrorDescription(err));
		}
		if (fm && UseSound) PlaySound(NameFileSound);
	}
}

//+------------------------------------------------------------------+
//|   StopLoss                                          |
//| :                                                       |
//|   ldStopLoss -  StopLoss                                  |
//+------------------------------------------------------------------+
void ModifyStopLossInPoint(int pp) {
	bool   fm;
	color  clModify;
	double ldSL=0, mp=MarketInfo(OrderSymbol(), MODE_POINT);
	int    err;
	
	if (OrderType()==OP_BUY) {
		ldSL=OrderOpenPrice()+pp*mp;
		clModify=clModifyBuy;
	}
	if (OrderType()==OP_SELL) {
		ldSL=OrderOpenPrice()-pp*mp;
		clModify=clModifySell;
	}
	if (IsTradeAllowed()) {
		fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldSL,OrderTakeProfit(),0,clModify);
		if (!fm) {
			err=GetLastError();
			Print("Error(",err,") modifying: ",ErrorDescription(err));
		}
		if (fm && UseSound) PlaySound(NameFileSound);
	}
}

//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
int ProfitPosition() {
	double pBid, pAsk, pp=MarketInfo(OrderSymbol(), MODE_POINT);
	double pr=0;
	
	if (OrderType()==OP_BUY) {
		pBid=MarketInfo(OrderSymbol(), MODE_BID);
		pr=(pBid-OrderOpenPrice())/pp;
	}
	if (OrderType()==OP_SELL) {
		pAsk=MarketInfo(OrderSymbol(), MODE_ASK);
		pr=(OrderOpenPrice()-pAsk)/pp;
	}
	return(MathRound(pr));
}

//+------------------------------------------------------------------+
//|  StopLoss                               |
//+------------------------------------------------------------------+
int StopLossInPoint() {
	double pp=MarketInfo(OrderSymbol(), MODE_POINT);
	double sp=0;
	
	if (OrderType()==OP_BUY) {
		sp=(OrderStopLoss()-OrderOpenPrice())/pp;
	}
	if (OrderType()==OP_SELL) {
		sp=(OrderOpenPrice()-OrderStopLoss())/pp;
	}
	if (OrderStopLoss()==0) sp=-OrderOpenPrice()/pp;
	return(MathRound(sp));
}
//+------------------------------------------------------------------+
//+--------------------------END OF PROGRAM--------------------------+


//----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE

int subGenerateMagicNumber(int MagicNumber, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "EURUSD")       isymbol = 1;
   else if (symbol == "GBPUSD")  isymbol = 2;
   else if (symbol == "USDJPY")  isymbol = 3;
   else if (symbol == "USDCHF")  isymbol = 4;
   else if (symbol == "AUDUSD")  isymbol = 5;
   else if (symbol == "USDCAD")  isymbol = 6;
   else if (symbol == "EURGBP")  isymbol = 7;
   else if (symbol == "EURJPY")  isymbol = 8;
   else if (symbol == "EURCHF")  isymbol = 9;
   else if (symbol == "EURAUD")  isymbol = 10;
   else if (symbol == "EURCAD")  isymbol = 11;
   else if (symbol == "GBPUSD")  isymbol = 12;
   else if (symbol == "GBPJPY")  isymbol = 13;
   else if (symbol == "GBPCHF")  isymbol = 14;
   else if (symbol == "GBPAUD")  isymbol = 15;
   else if (symbol == "GBPCAD")  isymbol = 16;
   else                          isymbol = 17;
   if(isymbol<10) MagicNumber = MagicNumber * 10;
   return (StrToInteger(StringConcatenate(MagicNumber, isymbol, timeFrame)));
   
}


